//
//  tLBulletHelloWorldPlugIn.h
//  tLBulletHelloWorld
//
//  Created by pascal on 5/5/11.
//  Copyright (c) 2011 t-linked.com . All rights reserved.
//

#import <Quartz/Quartz.h>
#import <OpenGL/OpenGL.h>

@interface tLBulletHelloWorldPlugIn : QCPlugIn
{

}

/*
Declare here the Obj-C 2.0 properties to be used as input and output ports for the plug-in e.g.
@property double inputFoo;
@property(assign) NSString* outputBar;
You can access their values in the appropriate plug-in methods using self.inputFoo or self.inputBar
*/

@property (assign) double inputRenderWidth;
@property (assign) double inputRenderHeight;

@property (assign) double inputWorldDimWidth;
@property (assign) double inputWorldDimHeight;
@property (assign) double inputWorldDimDepth;

@property (assign) double inputGravityX;
@property (assign) double inputGravityY;
@property (assign) double inputGravityZ;

@property  NSUInteger     inputSpheresCount;
@property (assign) CGColorRef inputSpheresColor;

@property  NSUInteger     inputBoxesCount;
@property (assign) CGColorRef inputBoxesColor;

@property NSUInteger      inputBoundingArea;






@end

@interface tLBulletHelloWorldPlugIn (Execution) 

// --- Rendering Methods ---
- (void) initGLScene: (CGLContextObj) cgl_ctx;
- (void) renderGLScene : (CGLContextObj) cgl_ctx;
- (void) drawBoundingBox: (CGLContextObj) cgl_ctx;
- (void) drawSpheres: (CGLContextObj) cgl_ctx;
- (void) drawBoxes: (CGLContextObj) cgl_ctx;

// --- Physics Methods ---
- (void) initPhysics;
- (void) createBoundingBody;
- (void) updateWorldDim;
- (void) addRandomSphere;
- (void) updateSpheresCount;
- (void) addRandomBox;
- (void) updateBoxesCount;


@end


